#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/mount.h>

/* umount() all the stuff in /etc/mtab.
Part of snailit, the init replacement for poly-p-ux by poly-p man.
Copyright (c) 2008 Matthew Kern under the GPLv2. */

// somebody please convert the fopen/fclose/fetc. stuff to open/close/etc...

//I'll do it myself later, unless someone would be so kind...

#define MAX_MOUNTS 20

int domyumount() {
	FILE *myfd = fopen("/etc/mtab", "r");
	char *pizza = (char*)malloc(128);
	char **great_pizza;
	int i = 0;
	great_pizza = (char**)malloc(MAX_MOUNTS*sizeof(char*));
	for (i=0; i<MAX_MOUNTS; i++) {
		great_pizza[i] = (char*)malloc(128*sizeof(char));
	}
	i=0;
	char *soda;
	char *beer;
	int seltzer;
	int crouton;
	int tomato = 0;
	char *salad = (char*)malloc(128);
	while (fgets(pizza, 1024, myfd)) {
		if (i >= MAX_MOUNTS) {
			printf("you have too many mounts. weirdo.\n");
			exit(1);
		}
		soda = (strstr(pizza, " ") + 1);
		beer = strstr(soda, " ");
		seltzer = beer - soda;
		strncpy(salad, soda, seltzer);
		salad[seltzer] = '\0';
		tomato = 0;
		if (i) {
			for (crouton = (i-1); crouton >= 0; crouton--) {
				if (!strcmp(salad, great_pizza[crouton])) {
					tomato = 1;
				}
			}
		}
		if (!tomato) {
			strcpy(great_pizza[i], salad);
			i++;
		}
	}
	fclose(myfd);
	i--;
	sync();
	for (crouton = i; crouton >= 0; crouton--) {
		if (umount(great_pizza[crouton])) {
			printf("warning: failed to umount %s... FIXME\n", great_pizza[crouton]);
			perror("umount");
			sleep(5);
		}
	}
	for (i=0; i<20; i++) {
		free(great_pizza[i]);
	}
	free(great_pizza);
	free(pizza);
	return 0;
}
