#include <stdio.h>
#include <sys/reboot.h>
#include <unistd.h>
#include <sys/types.h>
#include <signal.h>
#include <sys/wait.h>
/*
Snailit - an init implementation by Poly-p man for Poly-p-ux.
Copyright (c) 2008 Matthew Kern under the GPLv2
*/

#define YOUDIENOW 13579   //haltify me cap'n
#define COMEBACKPLZ 24680 //i'll be back - i'm rebooting.

#define VERSION "0.02"

extern char **environ; //for environment passing

void initial_env(); //I don't like adding an h file - I'm lazy.
int domyumount(); 
int shutmedownboss();
void goodmorning();

int parent(pid_t pidnum) {
	while (1) {};
	return 0;
}

int child(int whattodo) {
	sync();
	domyumount();
	if (whattodo == COMEBACKPLZ) {
		reboot(0x1234567); //restart
	}
	if (whattodo == YOUDIENOW) {
		reboot(0x4321fedc); //poweroff
	}
	return 0;	
}

int dofork(int commanf ) {
	shutmedownboss();
	pid_t childpid = fork();
	if (childpid == 0) {
		child(commanf);
	}
	else {
		parent(childpid);
	}
	return 0;
}

void wtdisig( int signal ) {
	if ( signal == SIGINT ) {
		printf("Init caught SIGINT. Rebooting...\n");
		dofork( COMEBACKPLZ );
	}
	if (signal == SIGUSR1 ) {
		printf("Init caught SIGUSR1. Halting...\n");
		dofork( YOUDIENOW );
	}
}

int main() {
	printf("%c[01m", 0x1B); //make me pretty (bright)... no color for the sake of monochrome monitors.
	//37 = fg white, 40 = bg black
	printf("\nSNAILIT version %s starting.\nSNAILIT is the INIT replacement for poly-p-ux by poly-p man.\nCopyright (C) 2008 Matthew Kern, under the GPL.\n", VERSION);
	printf("%c[00m\n", 0x1B); //return to normal. 1Bh is ^[, or escape.
	reboot(RB_DISABLE_CAD); //let ctrl-alt-del send sigint to me
	signal( SIGINT, wtdisig ); //define c-a-d/reboot catcher.
	signal( SIGUSR1, wtdisig ); //define halt catcher
	initial_env();
	goodmorning();
	nice(19 - nice(0)); //make me really, realy nice.
	while (1) { wait(NULL); } //LET'S GO ZOMBIE HUNTING!!!!
	// ...so it's not that exciting... but useful :D
	return 0; //nobody will *ever* get this far, but do it for good measure.
}
